﻿//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

// 
// This source code was auto-generated by Microsoft.VSDesigner, Version 4.0.30319.42000.
// 
#pragma warning disable 1591

namespace WebServices.SalesOpportunitiesServiceWeb {
    using System;
    using System.Web.Services;
    using System.Diagnostics;
    using System.Web.Services.Protocols;
    using System.Xml.Serialization;
    using System.ComponentModel;
    
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.7.3056.0")]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    [System.Web.Services.WebServiceBindingAttribute(Name="SalesOpportunitiesServiceSoap", Namespace="SalesOpportunitiesService")]
    public partial class SalesOpportunitiesService : System.Web.Services.Protocols.SoapHttpClientProtocol {
        
        private MsgHeader msgHeaderValueField;
        
        private System.Threading.SendOrPostCallback AddOperationCompleted;
        
        private System.Threading.SendOrPostCallback UpdateOperationCompleted;
        
        private System.Threading.SendOrPostCallback RemoveOperationCompleted;
        
        private System.Threading.SendOrPostCallback GetByParamsOperationCompleted;
        
        private System.Threading.SendOrPostCallback CloseOperationCompleted;
        
        private bool useDefaultCredentialsSetExplicitly;
        
        /// <remarks/>
        public SalesOpportunitiesService() {
            this.Url = global::WebServices.Properties.Settings.Default.WebServices_PurchaseOrderServiceWeb_PurchaseOrdersService;
            if ((this.IsLocalFileSystemWebService(this.Url) == true)) {
                this.UseDefaultCredentials = true;
                this.useDefaultCredentialsSetExplicitly = false;
            }
            else {
                this.useDefaultCredentialsSetExplicitly = true;
            }
        }
        
        public MsgHeader MsgHeaderValue {
            get {
                return this.msgHeaderValueField;
            }
            set {
                this.msgHeaderValueField = value;
            }
        }
        
        public new string Url {
            get {
                return base.Url;
            }
            set {
                if ((((this.IsLocalFileSystemWebService(base.Url) == true) 
                            && (this.useDefaultCredentialsSetExplicitly == false)) 
                            && (this.IsLocalFileSystemWebService(value) == false))) {
                    base.UseDefaultCredentials = false;
                }
                base.Url = value;
            }
        }
        
        public new bool UseDefaultCredentials {
            get {
                return base.UseDefaultCredentials;
            }
            set {
                base.UseDefaultCredentials = value;
                this.useDefaultCredentialsSetExplicitly = true;
            }
        }
        
        /// <remarks/>
        public event AddCompletedEventHandler AddCompleted;
        
        /// <remarks/>
        public event UpdateCompletedEventHandler UpdateCompleted;
        
        /// <remarks/>
        public event RemoveCompletedEventHandler RemoveCompleted;
        
        /// <remarks/>
        public event GetByParamsCompletedEventHandler GetByParamsCompleted;
        
        /// <remarks/>
        public event CloseCompletedEventHandler CloseCompleted;
        
        /// <remarks/>
        [System.Web.Services.Protocols.SoapHeaderAttribute("MsgHeaderValue")]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("SalesOpportunitiesService/Add", RequestNamespace="SalesOpportunitiesService", ResponseNamespace="http://www.sap.com/SBO/DIS", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        [return: System.Xml.Serialization.XmlElementAttribute("SalesOpportunitiesParams")]
        public SalesOpportunitiesParams Add([System.Xml.Serialization.XmlElementAttribute(Namespace="http://www.sap.com/SBO/DIS")] SalesOpportunities SalesOpportunities) {
            object[] results = this.Invoke("Add", new object[] {
                        SalesOpportunities});
            return ((SalesOpportunitiesParams)(results[0]));
        }
        
        /// <remarks/>
        public void AddAsync(SalesOpportunities SalesOpportunities) {
            this.AddAsync(SalesOpportunities, null);
        }
        
        /// <remarks/>
        public void AddAsync(SalesOpportunities SalesOpportunities, object userState) {
            if ((this.AddOperationCompleted == null)) {
                this.AddOperationCompleted = new System.Threading.SendOrPostCallback(this.OnAddOperationCompleted);
            }
            this.InvokeAsync("Add", new object[] {
                        SalesOpportunities}, this.AddOperationCompleted, userState);
        }
        
        private void OnAddOperationCompleted(object arg) {
            if ((this.AddCompleted != null)) {
                System.Web.Services.Protocols.InvokeCompletedEventArgs invokeArgs = ((System.Web.Services.Protocols.InvokeCompletedEventArgs)(arg));
                this.AddCompleted(this, new AddCompletedEventArgs(invokeArgs.Results, invokeArgs.Error, invokeArgs.Cancelled, invokeArgs.UserState));
            }
        }
        
        /// <remarks/>
        [System.Web.Services.Protocols.SoapHeaderAttribute("MsgHeaderValue")]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("SalesOpportunitiesService/Update", RequestNamespace="SalesOpportunitiesService", ResponseNamespace="http://www.sap.com/SBO/DIS", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        public void Update([System.Xml.Serialization.XmlElementAttribute(Namespace="http://www.sap.com/SBO/DIS")] SalesOpportunities SalesOpportunities) {
            this.Invoke("Update", new object[] {
                        SalesOpportunities});
        }
        
        /// <remarks/>
        public void UpdateAsync(SalesOpportunities SalesOpportunities) {
            this.UpdateAsync(SalesOpportunities, null);
        }
        
        /// <remarks/>
        public void UpdateAsync(SalesOpportunities SalesOpportunities, object userState) {
            if ((this.UpdateOperationCompleted == null)) {
                this.UpdateOperationCompleted = new System.Threading.SendOrPostCallback(this.OnUpdateOperationCompleted);
            }
            this.InvokeAsync("Update", new object[] {
                        SalesOpportunities}, this.UpdateOperationCompleted, userState);
        }
        
        private void OnUpdateOperationCompleted(object arg) {
            if ((this.UpdateCompleted != null)) {
                System.Web.Services.Protocols.InvokeCompletedEventArgs invokeArgs = ((System.Web.Services.Protocols.InvokeCompletedEventArgs)(arg));
                this.UpdateCompleted(this, new System.ComponentModel.AsyncCompletedEventArgs(invokeArgs.Error, invokeArgs.Cancelled, invokeArgs.UserState));
            }
        }
        
        /// <remarks/>
        [System.Web.Services.Protocols.SoapHeaderAttribute("MsgHeaderValue")]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("SalesOpportunitiesService/Remove", RequestNamespace="SalesOpportunitiesService", ResponseNamespace="http://www.sap.com/SBO/DIS", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        public void Remove([System.Xml.Serialization.XmlElementAttribute(Namespace="http://www.sap.com/SBO/DIS")] SalesOpportunitiesParams SalesOpportunitiesParams) {
            this.Invoke("Remove", new object[] {
                        SalesOpportunitiesParams});
        }
        
        /// <remarks/>
        public void RemoveAsync(SalesOpportunitiesParams SalesOpportunitiesParams) {
            this.RemoveAsync(SalesOpportunitiesParams, null);
        }
        
        /// <remarks/>
        public void RemoveAsync(SalesOpportunitiesParams SalesOpportunitiesParams, object userState) {
            if ((this.RemoveOperationCompleted == null)) {
                this.RemoveOperationCompleted = new System.Threading.SendOrPostCallback(this.OnRemoveOperationCompleted);
            }
            this.InvokeAsync("Remove", new object[] {
                        SalesOpportunitiesParams}, this.RemoveOperationCompleted, userState);
        }
        
        private void OnRemoveOperationCompleted(object arg) {
            if ((this.RemoveCompleted != null)) {
                System.Web.Services.Protocols.InvokeCompletedEventArgs invokeArgs = ((System.Web.Services.Protocols.InvokeCompletedEventArgs)(arg));
                this.RemoveCompleted(this, new System.ComponentModel.AsyncCompletedEventArgs(invokeArgs.Error, invokeArgs.Cancelled, invokeArgs.UserState));
            }
        }
        
        /// <remarks/>
        [System.Web.Services.Protocols.SoapHeaderAttribute("MsgHeaderValue")]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("SalesOpportunitiesService/GetByParams", RequestNamespace="SalesOpportunitiesService", ResponseNamespace="http://www.sap.com/SBO/DIS", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        [return: System.Xml.Serialization.XmlElementAttribute("SalesOpportunities")]
        public SalesOpportunities GetByParams([System.Xml.Serialization.XmlElementAttribute(Namespace="http://www.sap.com/SBO/DIS")] SalesOpportunitiesParams SalesOpportunitiesParams) {
            object[] results = this.Invoke("GetByParams", new object[] {
                        SalesOpportunitiesParams});
            return ((SalesOpportunities)(results[0]));
        }
        
        /// <remarks/>
        public void GetByParamsAsync(SalesOpportunitiesParams SalesOpportunitiesParams) {
            this.GetByParamsAsync(SalesOpportunitiesParams, null);
        }
        
        /// <remarks/>
        public void GetByParamsAsync(SalesOpportunitiesParams SalesOpportunitiesParams, object userState) {
            if ((this.GetByParamsOperationCompleted == null)) {
                this.GetByParamsOperationCompleted = new System.Threading.SendOrPostCallback(this.OnGetByParamsOperationCompleted);
            }
            this.InvokeAsync("GetByParams", new object[] {
                        SalesOpportunitiesParams}, this.GetByParamsOperationCompleted, userState);
        }
        
        private void OnGetByParamsOperationCompleted(object arg) {
            if ((this.GetByParamsCompleted != null)) {
                System.Web.Services.Protocols.InvokeCompletedEventArgs invokeArgs = ((System.Web.Services.Protocols.InvokeCompletedEventArgs)(arg));
                this.GetByParamsCompleted(this, new GetByParamsCompletedEventArgs(invokeArgs.Results, invokeArgs.Error, invokeArgs.Cancelled, invokeArgs.UserState));
            }
        }
        
        /// <remarks/>
        [System.Web.Services.Protocols.SoapHeaderAttribute("MsgHeaderValue")]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("SalesOpportunitiesService/Close", RequestNamespace="SalesOpportunitiesService", ResponseNamespace="http://www.sap.com/SBO/DIS", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        public void Close([System.Xml.Serialization.XmlElementAttribute(Namespace="http://www.sap.com/SBO/DIS")] SalesOpportunitiesParams SalesOpportunitiesParams) {
            this.Invoke("Close", new object[] {
                        SalesOpportunitiesParams});
        }
        
        /// <remarks/>
        public void CloseAsync(SalesOpportunitiesParams SalesOpportunitiesParams) {
            this.CloseAsync(SalesOpportunitiesParams, null);
        }
        
        /// <remarks/>
        public void CloseAsync(SalesOpportunitiesParams SalesOpportunitiesParams, object userState) {
            if ((this.CloseOperationCompleted == null)) {
                this.CloseOperationCompleted = new System.Threading.SendOrPostCallback(this.OnCloseOperationCompleted);
            }
            this.InvokeAsync("Close", new object[] {
                        SalesOpportunitiesParams}, this.CloseOperationCompleted, userState);
        }
        
        private void OnCloseOperationCompleted(object arg) {
            if ((this.CloseCompleted != null)) {
                System.Web.Services.Protocols.InvokeCompletedEventArgs invokeArgs = ((System.Web.Services.Protocols.InvokeCompletedEventArgs)(arg));
                this.CloseCompleted(this, new System.ComponentModel.AsyncCompletedEventArgs(invokeArgs.Error, invokeArgs.Cancelled, invokeArgs.UserState));
            }
        }
        
        /// <remarks/>
        public new void CancelAsync(object userState) {
            base.CancelAsync(userState);
        }
        
        private bool IsLocalFileSystemWebService(string url) {
            if (((url == null) 
                        || (url == string.Empty))) {
                return false;
            }
            System.Uri wsUri = new System.Uri(url);
            if (((wsUri.Port >= 1024) 
                        && (string.Compare(wsUri.Host, "localHost", System.StringComparison.OrdinalIgnoreCase) == 0))) {
                return true;
            }
            return false;
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.7.3056.0")]
    [System.SerializableAttribute()]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    [System.Xml.Serialization.XmlRootAttribute(Namespace="http://www.sap.com/SBO/DIS", IsNullable=false)]
    public partial class MsgHeader : System.Web.Services.Protocols.SoapHeader {
        
        private string sessionIDField;
        
        private MsgHeaderServiceName serviceNameField;
        
        private bool serviceNameFieldSpecified;
        
        /// <remarks/>
        public string SessionID {
            get {
                return this.sessionIDField;
            }
            set {
                this.sessionIDField = value;
            }
        }
        
        /// <remarks/>
        public MsgHeaderServiceName ServiceName {
            get {
                return this.serviceNameField;
            }
            set {
                this.serviceNameField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool ServiceNameSpecified {
            get {
                return this.serviceNameFieldSpecified;
            }
            set {
                this.serviceNameFieldSpecified = value;
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.7.3056.0")]
    [System.SerializableAttribute()]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public enum MsgHeaderServiceName {
        
        /// <remarks/>
        SalesOpportunitiesService,
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.7.3056.0")]
    [System.SerializableAttribute()]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public partial class SalesOpportunities {
        
        private long sequentialNoField;
        
        private bool sequentialNoFieldSpecified;
        
        private string cardCodeField;
        
        private long salesPersonField;
        
        private bool salesPersonFieldSpecified;
        
        private long contactPersonField;
        
        private bool contactPersonFieldSpecified;
        
        private long sourceField;
        
        private bool sourceFieldSpecified;
        
        private long interestField1Field;
        
        private bool interestField1FieldSpecified;
        
        private long interestField2Field;
        
        private bool interestField2FieldSpecified;
        
        private long interestField3Field;
        
        private bool interestField3FieldSpecified;
        
        private long interestLevelField;
        
        private bool interestLevelFieldSpecified;
        
        private System.DateTime startDateField;
        
        private bool startDateFieldSpecified;
        
        private System.DateTime predictedClosingDateField;
        
        private bool predictedClosingDateFieldSpecified;
        
        private double maxLocalTotalField;
        
        private bool maxLocalTotalFieldSpecified;
        
        private double maxSystemTotalField;
        
        private bool maxSystemTotalFieldSpecified;
        
        private double weightedSumLCField;
        
        private bool weightedSumLCFieldSpecified;
        
        private double weightedSumSCField;
        
        private bool weightedSumSCFieldSpecified;
        
        private double grossProfitField;
        
        private bool grossProfitFieldSpecified;
        
        private double grossProfitTotalLocalField;
        
        private bool grossProfitTotalLocalFieldSpecified;
        
        private double grossProfitTotalSystemField;
        
        private bool grossProfitTotalSystemFieldSpecified;
        
        private string remarksField;
        
        private SalesOpportunitiesStatus statusField;
        
        private bool statusFieldSpecified;
        
        private long reasonForClosingField;
        
        private bool reasonForClosingFieldSpecified;
        
        private double totalAmountLocalField;
        
        private bool totalAmountLocalFieldSpecified;
        
        private double totalAmounSystemField;
        
        private bool totalAmounSystemFieldSpecified;
        
        private double closingGrossProfitLocalField;
        
        private bool closingGrossProfitLocalFieldSpecified;
        
        private double closingGrossProfitSystemField;
        
        private bool closingGrossProfitSystemFieldSpecified;
        
        private double closingPercentageField;
        
        private bool closingPercentageFieldSpecified;
        
        private long currentStageNoField;
        
        private bool currentStageNoFieldSpecified;
        
        private long currentStageNumberField;
        
        private bool currentStageNumberFieldSpecified;
        
        private string opportunityNameField;
        
        private long industryField;
        
        private bool industryFieldSpecified;
        
        private string linkedDocumentTypeField;
        
        private long dataOwnershipfieldField;
        
        private bool dataOwnershipfieldFieldSpecified;
        
        private string statusRemarksField;
        
        private string projectCodeField;
        
        private string bPChanelNameField;
        
        private long userSignatureField;
        
        private bool userSignatureFieldSpecified;
        
        private string customerNameField;
        
        private string documentCheckboxField;
        
        private long linkedDocumentNumberField;
        
        private bool linkedDocumentNumberFieldSpecified;
        
        private long territoryField;
        
        private bool territoryFieldSpecified;
        
        private System.DateTime closingDateField;
        
        private bool closingDateFieldSpecified;
        
        private long bPChannelContactField;
        
        private bool bPChannelContactFieldSpecified;
        
        private string bPChanelCodeField;
        
        private SalesOpportunitiesClosingType closingTypeField;
        
        private bool closingTypeFieldSpecified;
        
        private long attachmentEntryField;
        
        private bool attachmentEntryFieldSpecified;
        
        private SalesOpportunitiesOpportunityType opportunityTypeField;
        
        private bool opportunityTypeFieldSpecified;
        
        private SalesOpportunitiesSalesOpportunitiesLine[] salesOpportunitiesLinesField;
        
        private SalesOpportunitiesSalesOpportunitiesCompetitionItem[] salesOpportunitiesCompetitionField;
        
        private SalesOpportunitiesSalesOpportunitiesPartner[] salesOpportunitiesPartnersField;
        
        private SalesOpportunitiesSalesOpportunitiesInterest[] salesOpportunitiesInterestsField;
        
        private SalesOpportunitiesSalesOpportunitiesReason[] salesOpportunitiesReasonsField;
        
        /// <remarks/>
        public long SequentialNo {
            get {
                return this.sequentialNoField;
            }
            set {
                this.sequentialNoField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool SequentialNoSpecified {
            get {
                return this.sequentialNoFieldSpecified;
            }
            set {
                this.sequentialNoFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public string CardCode {
            get {
                return this.cardCodeField;
            }
            set {
                this.cardCodeField = value;
            }
        }
        
        /// <remarks/>
        public long SalesPerson {
            get {
                return this.salesPersonField;
            }
            set {
                this.salesPersonField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool SalesPersonSpecified {
            get {
                return this.salesPersonFieldSpecified;
            }
            set {
                this.salesPersonFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long ContactPerson {
            get {
                return this.contactPersonField;
            }
            set {
                this.contactPersonField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool ContactPersonSpecified {
            get {
                return this.contactPersonFieldSpecified;
            }
            set {
                this.contactPersonFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long Source {
            get {
                return this.sourceField;
            }
            set {
                this.sourceField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool SourceSpecified {
            get {
                return this.sourceFieldSpecified;
            }
            set {
                this.sourceFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long InterestField1 {
            get {
                return this.interestField1Field;
            }
            set {
                this.interestField1Field = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool InterestField1Specified {
            get {
                return this.interestField1FieldSpecified;
            }
            set {
                this.interestField1FieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long InterestField2 {
            get {
                return this.interestField2Field;
            }
            set {
                this.interestField2Field = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool InterestField2Specified {
            get {
                return this.interestField2FieldSpecified;
            }
            set {
                this.interestField2FieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long InterestField3 {
            get {
                return this.interestField3Field;
            }
            set {
                this.interestField3Field = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool InterestField3Specified {
            get {
                return this.interestField3FieldSpecified;
            }
            set {
                this.interestField3FieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long InterestLevel {
            get {
                return this.interestLevelField;
            }
            set {
                this.interestLevelField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool InterestLevelSpecified {
            get {
                return this.interestLevelFieldSpecified;
            }
            set {
                this.interestLevelFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlElementAttribute(DataType="date")]
        public System.DateTime StartDate {
            get {
                return this.startDateField;
            }
            set {
                this.startDateField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool StartDateSpecified {
            get {
                return this.startDateFieldSpecified;
            }
            set {
                this.startDateFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlElementAttribute(DataType="date")]
        public System.DateTime PredictedClosingDate {
            get {
                return this.predictedClosingDateField;
            }
            set {
                this.predictedClosingDateField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool PredictedClosingDateSpecified {
            get {
                return this.predictedClosingDateFieldSpecified;
            }
            set {
                this.predictedClosingDateFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public double MaxLocalTotal {
            get {
                return this.maxLocalTotalField;
            }
            set {
                this.maxLocalTotalField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool MaxLocalTotalSpecified {
            get {
                return this.maxLocalTotalFieldSpecified;
            }
            set {
                this.maxLocalTotalFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public double MaxSystemTotal {
            get {
                return this.maxSystemTotalField;
            }
            set {
                this.maxSystemTotalField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool MaxSystemTotalSpecified {
            get {
                return this.maxSystemTotalFieldSpecified;
            }
            set {
                this.maxSystemTotalFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public double WeightedSumLC {
            get {
                return this.weightedSumLCField;
            }
            set {
                this.weightedSumLCField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool WeightedSumLCSpecified {
            get {
                return this.weightedSumLCFieldSpecified;
            }
            set {
                this.weightedSumLCFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public double WeightedSumSC {
            get {
                return this.weightedSumSCField;
            }
            set {
                this.weightedSumSCField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool WeightedSumSCSpecified {
            get {
                return this.weightedSumSCFieldSpecified;
            }
            set {
                this.weightedSumSCFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public double GrossProfit {
            get {
                return this.grossProfitField;
            }
            set {
                this.grossProfitField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool GrossProfitSpecified {
            get {
                return this.grossProfitFieldSpecified;
            }
            set {
                this.grossProfitFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public double GrossProfitTotalLocal {
            get {
                return this.grossProfitTotalLocalField;
            }
            set {
                this.grossProfitTotalLocalField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool GrossProfitTotalLocalSpecified {
            get {
                return this.grossProfitTotalLocalFieldSpecified;
            }
            set {
                this.grossProfitTotalLocalFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public double GrossProfitTotalSystem {
            get {
                return this.grossProfitTotalSystemField;
            }
            set {
                this.grossProfitTotalSystemField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool GrossProfitTotalSystemSpecified {
            get {
                return this.grossProfitTotalSystemFieldSpecified;
            }
            set {
                this.grossProfitTotalSystemFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public string Remarks {
            get {
                return this.remarksField;
            }
            set {
                this.remarksField = value;
            }
        }
        
        /// <remarks/>
        public SalesOpportunitiesStatus Status {
            get {
                return this.statusField;
            }
            set {
                this.statusField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool StatusSpecified {
            get {
                return this.statusFieldSpecified;
            }
            set {
                this.statusFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long ReasonForClosing {
            get {
                return this.reasonForClosingField;
            }
            set {
                this.reasonForClosingField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool ReasonForClosingSpecified {
            get {
                return this.reasonForClosingFieldSpecified;
            }
            set {
                this.reasonForClosingFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public double TotalAmountLocal {
            get {
                return this.totalAmountLocalField;
            }
            set {
                this.totalAmountLocalField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool TotalAmountLocalSpecified {
            get {
                return this.totalAmountLocalFieldSpecified;
            }
            set {
                this.totalAmountLocalFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public double TotalAmounSystem {
            get {
                return this.totalAmounSystemField;
            }
            set {
                this.totalAmounSystemField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool TotalAmounSystemSpecified {
            get {
                return this.totalAmounSystemFieldSpecified;
            }
            set {
                this.totalAmounSystemFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public double ClosingGrossProfitLocal {
            get {
                return this.closingGrossProfitLocalField;
            }
            set {
                this.closingGrossProfitLocalField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool ClosingGrossProfitLocalSpecified {
            get {
                return this.closingGrossProfitLocalFieldSpecified;
            }
            set {
                this.closingGrossProfitLocalFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public double ClosingGrossProfitSystem {
            get {
                return this.closingGrossProfitSystemField;
            }
            set {
                this.closingGrossProfitSystemField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool ClosingGrossProfitSystemSpecified {
            get {
                return this.closingGrossProfitSystemFieldSpecified;
            }
            set {
                this.closingGrossProfitSystemFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public double ClosingPercentage {
            get {
                return this.closingPercentageField;
            }
            set {
                this.closingPercentageField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool ClosingPercentageSpecified {
            get {
                return this.closingPercentageFieldSpecified;
            }
            set {
                this.closingPercentageFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long CurrentStageNo {
            get {
                return this.currentStageNoField;
            }
            set {
                this.currentStageNoField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool CurrentStageNoSpecified {
            get {
                return this.currentStageNoFieldSpecified;
            }
            set {
                this.currentStageNoFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long CurrentStageNumber {
            get {
                return this.currentStageNumberField;
            }
            set {
                this.currentStageNumberField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool CurrentStageNumberSpecified {
            get {
                return this.currentStageNumberFieldSpecified;
            }
            set {
                this.currentStageNumberFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public string OpportunityName {
            get {
                return this.opportunityNameField;
            }
            set {
                this.opportunityNameField = value;
            }
        }
        
        /// <remarks/>
        public long Industry {
            get {
                return this.industryField;
            }
            set {
                this.industryField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool IndustrySpecified {
            get {
                return this.industryFieldSpecified;
            }
            set {
                this.industryFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public string LinkedDocumentType {
            get {
                return this.linkedDocumentTypeField;
            }
            set {
                this.linkedDocumentTypeField = value;
            }
        }
        
        /// <remarks/>
        public long DataOwnershipfield {
            get {
                return this.dataOwnershipfieldField;
            }
            set {
                this.dataOwnershipfieldField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool DataOwnershipfieldSpecified {
            get {
                return this.dataOwnershipfieldFieldSpecified;
            }
            set {
                this.dataOwnershipfieldFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public string StatusRemarks {
            get {
                return this.statusRemarksField;
            }
            set {
                this.statusRemarksField = value;
            }
        }
        
        /// <remarks/>
        public string ProjectCode {
            get {
                return this.projectCodeField;
            }
            set {
                this.projectCodeField = value;
            }
        }
        
        /// <remarks/>
        public string BPChanelName {
            get {
                return this.bPChanelNameField;
            }
            set {
                this.bPChanelNameField = value;
            }
        }
        
        /// <remarks/>
        public long UserSignature {
            get {
                return this.userSignatureField;
            }
            set {
                this.userSignatureField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool UserSignatureSpecified {
            get {
                return this.userSignatureFieldSpecified;
            }
            set {
                this.userSignatureFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public string CustomerName {
            get {
                return this.customerNameField;
            }
            set {
                this.customerNameField = value;
            }
        }
        
        /// <remarks/>
        public string DocumentCheckbox {
            get {
                return this.documentCheckboxField;
            }
            set {
                this.documentCheckboxField = value;
            }
        }
        
        /// <remarks/>
        public long LinkedDocumentNumber {
            get {
                return this.linkedDocumentNumberField;
            }
            set {
                this.linkedDocumentNumberField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool LinkedDocumentNumberSpecified {
            get {
                return this.linkedDocumentNumberFieldSpecified;
            }
            set {
                this.linkedDocumentNumberFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long Territory {
            get {
                return this.territoryField;
            }
            set {
                this.territoryField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool TerritorySpecified {
            get {
                return this.territoryFieldSpecified;
            }
            set {
                this.territoryFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlElementAttribute(DataType="date")]
        public System.DateTime ClosingDate {
            get {
                return this.closingDateField;
            }
            set {
                this.closingDateField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool ClosingDateSpecified {
            get {
                return this.closingDateFieldSpecified;
            }
            set {
                this.closingDateFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long BPChannelContact {
            get {
                return this.bPChannelContactField;
            }
            set {
                this.bPChannelContactField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool BPChannelContactSpecified {
            get {
                return this.bPChannelContactFieldSpecified;
            }
            set {
                this.bPChannelContactFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public string BPChanelCode {
            get {
                return this.bPChanelCodeField;
            }
            set {
                this.bPChanelCodeField = value;
            }
        }
        
        /// <remarks/>
        public SalesOpportunitiesClosingType ClosingType {
            get {
                return this.closingTypeField;
            }
            set {
                this.closingTypeField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool ClosingTypeSpecified {
            get {
                return this.closingTypeFieldSpecified;
            }
            set {
                this.closingTypeFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long AttachmentEntry {
            get {
                return this.attachmentEntryField;
            }
            set {
                this.attachmentEntryField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool AttachmentEntrySpecified {
            get {
                return this.attachmentEntryFieldSpecified;
            }
            set {
                this.attachmentEntryFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public SalesOpportunitiesOpportunityType OpportunityType {
            get {
                return this.opportunityTypeField;
            }
            set {
                this.opportunityTypeField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool OpportunityTypeSpecified {
            get {
                return this.opportunityTypeFieldSpecified;
            }
            set {
                this.opportunityTypeFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlArrayItemAttribute("SalesOpportunitiesLine", IsNullable=false)]
        public SalesOpportunitiesSalesOpportunitiesLine[] SalesOpportunitiesLines {
            get {
                return this.salesOpportunitiesLinesField;
            }
            set {
                this.salesOpportunitiesLinesField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlArrayItemAttribute("SalesOpportunitiesCompetitionItem", IsNullable=false)]
        public SalesOpportunitiesSalesOpportunitiesCompetitionItem[] SalesOpportunitiesCompetition {
            get {
                return this.salesOpportunitiesCompetitionField;
            }
            set {
                this.salesOpportunitiesCompetitionField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlArrayItemAttribute("SalesOpportunitiesPartner", IsNullable=false)]
        public SalesOpportunitiesSalesOpportunitiesPartner[] SalesOpportunitiesPartners {
            get {
                return this.salesOpportunitiesPartnersField;
            }
            set {
                this.salesOpportunitiesPartnersField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlArrayItemAttribute("SalesOpportunitiesInterest", IsNullable=false)]
        public SalesOpportunitiesSalesOpportunitiesInterest[] SalesOpportunitiesInterests {
            get {
                return this.salesOpportunitiesInterestsField;
            }
            set {
                this.salesOpportunitiesInterestsField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlArrayItemAttribute("SalesOpportunitiesReason", IsNullable=false)]
        public SalesOpportunitiesSalesOpportunitiesReason[] SalesOpportunitiesReasons {
            get {
                return this.salesOpportunitiesReasonsField;
            }
            set {
                this.salesOpportunitiesReasonsField = value;
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.7.3056.0")]
    [System.SerializableAttribute()]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public enum SalesOpportunitiesStatus {
        
        /// <remarks/>
        sos_Open,
        
        /// <remarks/>
        sos_Missed,
        
        /// <remarks/>
        sos_Sold,
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.7.3056.0")]
    [System.SerializableAttribute()]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public enum SalesOpportunitiesClosingType {
        
        /// <remarks/>
        sos_Months,
        
        /// <remarks/>
        sos_Weeks,
        
        /// <remarks/>
        sos_Days,
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.7.3056.0")]
    [System.SerializableAttribute()]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public enum SalesOpportunitiesOpportunityType {
        
        /// <remarks/>
        boOpSales,
        
        /// <remarks/>
        boOpPurchasing,
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.7.3056.0")]
    [System.SerializableAttribute()]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public partial class SalesOpportunitiesSalesOpportunitiesLine {
        
        private long lineNumField;
        
        private bool lineNumFieldSpecified;
        
        private long salesPersonField;
        
        private bool salesPersonFieldSpecified;
        
        private System.DateTime startDateField;
        
        private bool startDateFieldSpecified;
        
        private System.DateTime closingDateField;
        
        private bool closingDateFieldSpecified;
        
        private long stageKeyField;
        
        private bool stageKeyFieldSpecified;
        
        private double percentageRateField;
        
        private bool percentageRateFieldSpecified;
        
        private double maxLocalTotalField;
        
        private bool maxLocalTotalFieldSpecified;
        
        private double maxSystemTotalField;
        
        private bool maxSystemTotalFieldSpecified;
        
        private string remarksField;
        
        private SalesOpportunitiesSalesOpportunitiesLineContact contactField;
        
        private bool contactFieldSpecified;
        
        private SalesOpportunitiesSalesOpportunitiesLineStatus statusField;
        
        private bool statusFieldSpecified;
        
        private double weightedAmountLocalField;
        
        private bool weightedAmountLocalFieldSpecified;
        
        private double weightedAmountSystemField;
        
        private bool weightedAmountSystemFieldSpecified;
        
        private long documentNumberField;
        
        private bool documentNumberFieldSpecified;
        
        private SalesOpportunitiesSalesOpportunitiesLineDocumentType documentTypeField;
        
        private bool documentTypeFieldSpecified;
        
        private SalesOpportunitiesSalesOpportunitiesLineDocumentCheckbox documentCheckboxField;
        
        private bool documentCheckboxFieldSpecified;
        
        private long contactPersonField;
        
        private bool contactPersonFieldSpecified;
        
        private string bPChanelNameField;
        
        private string bPChanelCodeField;
        
        private long sequenceNoField;
        
        private bool sequenceNoFieldSpecified;
        
        private long dataOwnershipfieldField;
        
        private bool dataOwnershipfieldFieldSpecified;
        
        private long bPChannelContactField;
        
        private bool bPChannelContactFieldSpecified;
        
        /// <remarks/>
        public long LineNum {
            get {
                return this.lineNumField;
            }
            set {
                this.lineNumField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool LineNumSpecified {
            get {
                return this.lineNumFieldSpecified;
            }
            set {
                this.lineNumFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long SalesPerson {
            get {
                return this.salesPersonField;
            }
            set {
                this.salesPersonField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool SalesPersonSpecified {
            get {
                return this.salesPersonFieldSpecified;
            }
            set {
                this.salesPersonFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlElementAttribute(DataType="date")]
        public System.DateTime StartDate {
            get {
                return this.startDateField;
            }
            set {
                this.startDateField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool StartDateSpecified {
            get {
                return this.startDateFieldSpecified;
            }
            set {
                this.startDateFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlElementAttribute(DataType="date")]
        public System.DateTime ClosingDate {
            get {
                return this.closingDateField;
            }
            set {
                this.closingDateField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool ClosingDateSpecified {
            get {
                return this.closingDateFieldSpecified;
            }
            set {
                this.closingDateFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long StageKey {
            get {
                return this.stageKeyField;
            }
            set {
                this.stageKeyField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool StageKeySpecified {
            get {
                return this.stageKeyFieldSpecified;
            }
            set {
                this.stageKeyFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public double PercentageRate {
            get {
                return this.percentageRateField;
            }
            set {
                this.percentageRateField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool PercentageRateSpecified {
            get {
                return this.percentageRateFieldSpecified;
            }
            set {
                this.percentageRateFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public double MaxLocalTotal {
            get {
                return this.maxLocalTotalField;
            }
            set {
                this.maxLocalTotalField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool MaxLocalTotalSpecified {
            get {
                return this.maxLocalTotalFieldSpecified;
            }
            set {
                this.maxLocalTotalFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public double MaxSystemTotal {
            get {
                return this.maxSystemTotalField;
            }
            set {
                this.maxSystemTotalField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool MaxSystemTotalSpecified {
            get {
                return this.maxSystemTotalFieldSpecified;
            }
            set {
                this.maxSystemTotalFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public string Remarks {
            get {
                return this.remarksField;
            }
            set {
                this.remarksField = value;
            }
        }
        
        /// <remarks/>
        public SalesOpportunitiesSalesOpportunitiesLineContact Contact {
            get {
                return this.contactField;
            }
            set {
                this.contactField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool ContactSpecified {
            get {
                return this.contactFieldSpecified;
            }
            set {
                this.contactFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public SalesOpportunitiesSalesOpportunitiesLineStatus Status {
            get {
                return this.statusField;
            }
            set {
                this.statusField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool StatusSpecified {
            get {
                return this.statusFieldSpecified;
            }
            set {
                this.statusFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public double WeightedAmountLocal {
            get {
                return this.weightedAmountLocalField;
            }
            set {
                this.weightedAmountLocalField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool WeightedAmountLocalSpecified {
            get {
                return this.weightedAmountLocalFieldSpecified;
            }
            set {
                this.weightedAmountLocalFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public double WeightedAmountSystem {
            get {
                return this.weightedAmountSystemField;
            }
            set {
                this.weightedAmountSystemField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool WeightedAmountSystemSpecified {
            get {
                return this.weightedAmountSystemFieldSpecified;
            }
            set {
                this.weightedAmountSystemFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long DocumentNumber {
            get {
                return this.documentNumberField;
            }
            set {
                this.documentNumberField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool DocumentNumberSpecified {
            get {
                return this.documentNumberFieldSpecified;
            }
            set {
                this.documentNumberFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public SalesOpportunitiesSalesOpportunitiesLineDocumentType DocumentType {
            get {
                return this.documentTypeField;
            }
            set {
                this.documentTypeField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool DocumentTypeSpecified {
            get {
                return this.documentTypeFieldSpecified;
            }
            set {
                this.documentTypeFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public SalesOpportunitiesSalesOpportunitiesLineDocumentCheckbox DocumentCheckbox {
            get {
                return this.documentCheckboxField;
            }
            set {
                this.documentCheckboxField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool DocumentCheckboxSpecified {
            get {
                return this.documentCheckboxFieldSpecified;
            }
            set {
                this.documentCheckboxFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long ContactPerson {
            get {
                return this.contactPersonField;
            }
            set {
                this.contactPersonField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool ContactPersonSpecified {
            get {
                return this.contactPersonFieldSpecified;
            }
            set {
                this.contactPersonFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public string BPChanelName {
            get {
                return this.bPChanelNameField;
            }
            set {
                this.bPChanelNameField = value;
            }
        }
        
        /// <remarks/>
        public string BPChanelCode {
            get {
                return this.bPChanelCodeField;
            }
            set {
                this.bPChanelCodeField = value;
            }
        }
        
        /// <remarks/>
        public long SequenceNo {
            get {
                return this.sequenceNoField;
            }
            set {
                this.sequenceNoField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool SequenceNoSpecified {
            get {
                return this.sequenceNoFieldSpecified;
            }
            set {
                this.sequenceNoFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long DataOwnershipfield {
            get {
                return this.dataOwnershipfieldField;
            }
            set {
                this.dataOwnershipfieldField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool DataOwnershipfieldSpecified {
            get {
                return this.dataOwnershipfieldFieldSpecified;
            }
            set {
                this.dataOwnershipfieldFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long BPChannelContact {
            get {
                return this.bPChannelContactField;
            }
            set {
                this.bPChannelContactField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool BPChannelContactSpecified {
            get {
                return this.bPChannelContactFieldSpecified;
            }
            set {
                this.bPChannelContactFieldSpecified = value;
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.7.3056.0")]
    [System.SerializableAttribute()]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public enum SalesOpportunitiesSalesOpportunitiesLineContact {
        
        /// <remarks/>
        tNO,
        
        /// <remarks/>
        tYES,
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.7.3056.0")]
    [System.SerializableAttribute()]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public enum SalesOpportunitiesSalesOpportunitiesLineStatus {
        
        /// <remarks/>
        so_Open,
        
        /// <remarks/>
        so_Closed,
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.7.3056.0")]
    [System.SerializableAttribute()]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public enum SalesOpportunitiesSalesOpportunitiesLineDocumentType {
        
        /// <remarks/>
        bodt_Invoice,
        
        /// <remarks/>
        bodt_CreditNote,
        
        /// <remarks/>
        bodt_DeliveryNote,
        
        /// <remarks/>
        bodt_Return,
        
        /// <remarks/>
        bodt_Order,
        
        /// <remarks/>
        bodt_PurchaseInvoice,
        
        /// <remarks/>
        bodt_PurchaseCreditNote,
        
        /// <remarks/>
        bodt_PurchaseDeliveryNote,
        
        /// <remarks/>
        bodt_PurchaseReturn,
        
        /// <remarks/>
        bodt_PurchaseOrder,
        
        /// <remarks/>
        bodt_Quotation,
        
        /// <remarks/>
        bodt_CorrectionAPInvoice,
        
        /// <remarks/>
        bodt_CorrectionARInvoice,
        
        /// <remarks/>
        bodt_Zero,
        
        /// <remarks/>
        bodt_MinusOne,
        
        /// <remarks/>
        bodt_PurchaseQutation,
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.7.3056.0")]
    [System.SerializableAttribute()]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public enum SalesOpportunitiesSalesOpportunitiesLineDocumentCheckbox {
        
        /// <remarks/>
        tNO,
        
        /// <remarks/>
        tYES,
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.7.3056.0")]
    [System.SerializableAttribute()]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public partial class SalesOpportunitiesSalesOpportunitiesCompetitionItem {
        
        private long rowNoField;
        
        private bool rowNoFieldSpecified;
        
        private long competitionField;
        
        private bool competitionFieldSpecified;
        
        private string detailsField;
        
        private long sequenceNoField;
        
        private bool sequenceNoFieldSpecified;
        
        private string wonOrLostField;
        
        /// <remarks/>
        public long RowNo {
            get {
                return this.rowNoField;
            }
            set {
                this.rowNoField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool RowNoSpecified {
            get {
                return this.rowNoFieldSpecified;
            }
            set {
                this.rowNoFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long Competition {
            get {
                return this.competitionField;
            }
            set {
                this.competitionField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool CompetitionSpecified {
            get {
                return this.competitionFieldSpecified;
            }
            set {
                this.competitionFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public string Details {
            get {
                return this.detailsField;
            }
            set {
                this.detailsField = value;
            }
        }
        
        /// <remarks/>
        public long SequenceNo {
            get {
                return this.sequenceNoField;
            }
            set {
                this.sequenceNoField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool SequenceNoSpecified {
            get {
                return this.sequenceNoFieldSpecified;
            }
            set {
                this.sequenceNoFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public string WonOrLost {
            get {
                return this.wonOrLostField;
            }
            set {
                this.wonOrLostField = value;
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.7.3056.0")]
    [System.SerializableAttribute()]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public partial class SalesOpportunitiesSalesOpportunitiesPartner {
        
        private long rowNoField;
        
        private bool rowNoFieldSpecified;
        
        private long partnersField;
        
        private bool partnersFieldSpecified;
        
        private string detailsField;
        
        private long relationshipCodeField;
        
        private bool relationshipCodeFieldSpecified;
        
        private long sequenceNoField;
        
        private bool sequenceNoFieldSpecified;
        
        /// <remarks/>
        public long RowNo {
            get {
                return this.rowNoField;
            }
            set {
                this.rowNoField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool RowNoSpecified {
            get {
                return this.rowNoFieldSpecified;
            }
            set {
                this.rowNoFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long Partners {
            get {
                return this.partnersField;
            }
            set {
                this.partnersField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool PartnersSpecified {
            get {
                return this.partnersFieldSpecified;
            }
            set {
                this.partnersFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public string Details {
            get {
                return this.detailsField;
            }
            set {
                this.detailsField = value;
            }
        }
        
        /// <remarks/>
        public long RelationshipCode {
            get {
                return this.relationshipCodeField;
            }
            set {
                this.relationshipCodeField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool RelationshipCodeSpecified {
            get {
                return this.relationshipCodeFieldSpecified;
            }
            set {
                this.relationshipCodeFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long SequenceNo {
            get {
                return this.sequenceNoField;
            }
            set {
                this.sequenceNoField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool SequenceNoSpecified {
            get {
                return this.sequenceNoFieldSpecified;
            }
            set {
                this.sequenceNoFieldSpecified = value;
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.7.3056.0")]
    [System.SerializableAttribute()]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public partial class SalesOpportunitiesSalesOpportunitiesInterest {
        
        private long rowNoField;
        
        private bool rowNoFieldSpecified;
        
        private long sequenceNoField;
        
        private bool sequenceNoFieldSpecified;
        
        private SalesOpportunitiesSalesOpportunitiesInterestPrimaryInterest primaryInterestField;
        
        private bool primaryInterestFieldSpecified;
        
        private long interestIdField;
        
        private bool interestIdFieldSpecified;
        
        /// <remarks/>
        public long RowNo {
            get {
                return this.rowNoField;
            }
            set {
                this.rowNoField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool RowNoSpecified {
            get {
                return this.rowNoFieldSpecified;
            }
            set {
                this.rowNoFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long SequenceNo {
            get {
                return this.sequenceNoField;
            }
            set {
                this.sequenceNoField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool SequenceNoSpecified {
            get {
                return this.sequenceNoFieldSpecified;
            }
            set {
                this.sequenceNoFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public SalesOpportunitiesSalesOpportunitiesInterestPrimaryInterest PrimaryInterest {
            get {
                return this.primaryInterestField;
            }
            set {
                this.primaryInterestField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool PrimaryInterestSpecified {
            get {
                return this.primaryInterestFieldSpecified;
            }
            set {
                this.primaryInterestFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long InterestId {
            get {
                return this.interestIdField;
            }
            set {
                this.interestIdField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool InterestIdSpecified {
            get {
                return this.interestIdFieldSpecified;
            }
            set {
                this.interestIdFieldSpecified = value;
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.7.3056.0")]
    [System.SerializableAttribute()]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public enum SalesOpportunitiesSalesOpportunitiesInterestPrimaryInterest {
        
        /// <remarks/>
        tNO,
        
        /// <remarks/>
        tYES,
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.7.3056.0")]
    [System.SerializableAttribute()]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public partial class SalesOpportunitiesSalesOpportunitiesReason {
        
        private long rowNoField;
        
        private bool rowNoFieldSpecified;
        
        private long sequenceNoField;
        
        private bool sequenceNoFieldSpecified;
        
        private long reasonField;
        
        private bool reasonFieldSpecified;
        
        /// <remarks/>
        public long RowNo {
            get {
                return this.rowNoField;
            }
            set {
                this.rowNoField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool RowNoSpecified {
            get {
                return this.rowNoFieldSpecified;
            }
            set {
                this.rowNoFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long SequenceNo {
            get {
                return this.sequenceNoField;
            }
            set {
                this.sequenceNoField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool SequenceNoSpecified {
            get {
                return this.sequenceNoFieldSpecified;
            }
            set {
                this.sequenceNoFieldSpecified = value;
            }
        }
        
        /// <remarks/>
        public long Reason {
            get {
                return this.reasonField;
            }
            set {
                this.reasonField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool ReasonSpecified {
            get {
                return this.reasonFieldSpecified;
            }
            set {
                this.reasonFieldSpecified = value;
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Xml", "4.7.3056.0")]
    [System.SerializableAttribute()]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    [System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true, Namespace="http://www.sap.com/SBO/DIS")]
    public partial class SalesOpportunitiesParams {
        
        private long sequentialNoField;
        
        private bool sequentialNoFieldSpecified;
        
        /// <remarks/>
        public long SequentialNo {
            get {
                return this.sequentialNoField;
            }
            set {
                this.sequentialNoField = value;
            }
        }
        
        /// <remarks/>
        [System.Xml.Serialization.XmlIgnoreAttribute()]
        public bool SequentialNoSpecified {
            get {
                return this.sequentialNoFieldSpecified;
            }
            set {
                this.sequentialNoFieldSpecified = value;
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.7.3056.0")]
    public delegate void AddCompletedEventHandler(object sender, AddCompletedEventArgs e);
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.7.3056.0")]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    public partial class AddCompletedEventArgs : System.ComponentModel.AsyncCompletedEventArgs {
        
        private object[] results;
        
        internal AddCompletedEventArgs(object[] results, System.Exception exception, bool cancelled, object userState) : 
                base(exception, cancelled, userState) {
            this.results = results;
        }
        
        /// <remarks/>
        public SalesOpportunitiesParams Result {
            get {
                this.RaiseExceptionIfNecessary();
                return ((SalesOpportunitiesParams)(this.results[0]));
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.7.3056.0")]
    public delegate void UpdateCompletedEventHandler(object sender, System.ComponentModel.AsyncCompletedEventArgs e);
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.7.3056.0")]
    public delegate void RemoveCompletedEventHandler(object sender, System.ComponentModel.AsyncCompletedEventArgs e);
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.7.3056.0")]
    public delegate void GetByParamsCompletedEventHandler(object sender, GetByParamsCompletedEventArgs e);
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.7.3056.0")]
    [System.Diagnostics.DebuggerStepThroughAttribute()]
    [System.ComponentModel.DesignerCategoryAttribute("code")]
    public partial class GetByParamsCompletedEventArgs : System.ComponentModel.AsyncCompletedEventArgs {
        
        private object[] results;
        
        internal GetByParamsCompletedEventArgs(object[] results, System.Exception exception, bool cancelled, object userState) : 
                base(exception, cancelled, userState) {
            this.results = results;
        }
        
        /// <remarks/>
        public SalesOpportunities Result {
            get {
                this.RaiseExceptionIfNecessary();
                return ((SalesOpportunities)(this.results[0]));
            }
        }
    }
    
    /// <remarks/>
    [System.CodeDom.Compiler.GeneratedCodeAttribute("System.Web.Services", "4.7.3056.0")]
    public delegate void CloseCompletedEventHandler(object sender, System.ComponentModel.AsyncCompletedEventArgs e);
}

#pragma warning restore 1591